﻿' Normally true --> Visible but if parameter is set to "1",
'  true --> Collapsed
Public Class BooleanToVisibilityConverter
    Implements IValueConverter
    Public Function Convert(ByVal value As Object,
                            ByVal targetType As Type,
                            ByVal parameter As Object,
                            ByVal culture As CultureInfo) As Object Implements IValueConverter.Convert
        Dim boolValue = CBool(value)

        If parameter IsNot Nothing AndAlso
            TypeOf parameter Is String AndAlso
            TryCast(parameter, String) = "1" Then boolValue = boolValue Xor True

        Return If(boolValue, Visibility.Visible, Visibility.Collapsed)
    End Function

    Public Function ConvertBack(ByVal value As Object,
                                ByVal targetType As Type,
                                ByVal parameter As Object,
                                ByVal culture As CultureInfo) As Object Implements IValueConverter.ConvertBack
        If parameter IsNot Nothing AndAlso
            TypeOf parameter Is String AndAlso
            TryCast(parameter, String) =
            "1" Then Return CType(value, Visibility) <> Visibility.Visible

        Return CType(value, Visibility) = Visibility.Visible
    End Function
End Class

