﻿Public Class MemoInfo
    Implements INotifyPropertyChanged

    Dim _isPlaying As Boolean

    ' Event is only fired for IsPlaying property
    Public Event PropertyChanged As PropertyChangedEventHandler Implements INotifyPropertyChanged.PropertyChanged

    Public Sub New(ByVal filename As String,
                   ByVal filesize As Long,
                   ByVal duration As TimeSpan)
        Me.FileName = filename

        Me.SpaceTime = New SpaceTime With {.Space = filesize, .Time = duration}
    End Sub

    Public Sub New(ByVal datetime As Date, ByVal filesize As Long, ByVal duration As TimeSpan)
        ' Convert DateTime to packed string

        FileName = String.Format("{0:D4}{1:D2}{2:D2}{3:D2}{4:D2}{5:D2}{6:D3}",
                                 datetime.Year,
                                 datetime.Month,
                                 datetime.Day,
                                 datetime.Hour,
                                 datetime.Minute,
                                 datetime.Second,
                                 datetime.Millisecond)
    End Sub

    Public Property IsPlaying() As Boolean
        Set(ByVal value As Boolean)
            If value <> _isPlaying Then
                _isPlaying = value

                RaiseEvent PropertyChanged(Me, New PropertyChangedEventArgs("IsPlaying"))
            End If
        End Set
        Get
            Return _isPlaying
        End Get
    End Property

    Public Property IsPaused() As Boolean


    Public Property FileName() As String

    Public Property SpaceTime() As SpaceTime

    Public ReadOnly Property DateTime() As Date
        Get
            ' Convert packed string to DateTime
            Dim year = Integer.Parse(FileName.Substring(0, 4))
            Dim mon = Integer.Parse(FileName.Substring(4, 2))
            Dim day = Integer.Parse(FileName.Substring(6, 2))
            Dim hour = Integer.Parse(FileName.Substring(8, 2))
            Dim min = Integer.Parse(FileName.Substring(10, 2))
            Dim sec = Integer.Parse(FileName.Substring(12, 2))
            Dim msec = Integer.Parse(FileName.Substring(14, 3))

            Dim dt As New Date(year, mon, day, hour, min, sec, msec, DateTimeKind.Utc)
            Return dt.ToLocalTime()
        End Get
    End Property
End Class

